import type { constraint, Default, Literal, Narrowed, normalizeLimit, of, Optional, Predicate } from "../inference.ts";
export type AtOrAfter<rule> = {
    atOrAfter: constraint<rule>;
};
export type AtOrBefore<rule> = {
    atOrBefore: constraint<rule>;
};
export type After<rule> = {
    after: constraint<rule>;
};
export type Before<rule> = {
    before: constraint<rule>;
};
export declare namespace Date {
    type atOrAfter<rule> = of<Date, AtOrAfter<rule>>;
    type after<rule> = of<Date, After<rule>>;
    type atOrBefore<rule> = of<Date, AtOrBefore<rule>>;
    type before<rule> = of<Date, Before<rule>>;
    type narrowed = of<Date, Narrowed>;
    type optional = of<Date, Optional>;
    type defaultsTo<rule> = of<Date, Default<rule>>;
    type branded<rule> = of<Date, Predicate<rule>>;
    type literal<rule> = of<Date, Literal<rule>>;
    type is<attributes> = of<Date, attributes>;
    type afterSchemaToConstraint<schema, rule> = schema extends {
        exclusive: true;
    } ? After<normalizeLimit<rule>> : AtOrAfter<normalizeLimit<rule>>;
    type beforeSchemaToConstraint<schema, rule> = schema extends {
        exclusive: true;
    } ? Before<normalizeLimit<rule>> : AtOrBefore<normalizeLimit<rule>>;
    type applyAttribute<attribute> = attribute extends After<infer rule> ? after<rule> : attribute extends Before<infer rule> ? before<rule> : attribute extends AtOrAfter<infer rule> ? atOrAfter<rule> : attribute extends AtOrBefore<infer rule> ? atOrBefore<rule> : attribute extends Optional ? optional : attribute extends Default<infer rule> ? defaultsTo<rule> : attribute extends Predicate<infer rule> ? branded<rule> : never;
}
