import { $arkTypeRegistry, scope } from "../scope.js";
import { arkBuiltins } from "./builtins.js";
import { arkPrototypes } from "./constructors/constructors.js";
import { number } from "./number/number.js";
import { string } from "./string/string.js";
import { arkTsGenerics, arkTsKeywords, object, unknown } from "./ts.js";
$arkTypeRegistry.typeAttachments = {
    ...arkTsKeywords,
    Key: arkBuiltins.Key,
    Record: arkTsGenerics.Record
};
export const ark = scope({
    ...arkTsKeywords,
    ...arkTsGenerics,
    ...arkPrototypes,
    ...arkBuiltins,
    string,
    number,
    object,
    unknown
}, { prereducedAliases: true, ambient: true });
export const keywords = ark.export();
export const type = ark.type;
export const generic = ark.generic;
export const schema = ark.schema;
export const define = ark.define;
export const declare = ark.declare;
