import type { AtLeastLength, AtMostLength, Default, ExactlyLength, LessThanLength, MoreThanLength, Narrowed, Optional, Predicate, brand } from "../inference.ts";
import type { Matching } from "./string.ts";
declare namespace string {
    type atLeastLength<rule> = brand<string, AtLeastLength<rule>>;
    type moreThanLength<rule> = brand<string, MoreThanLength<rule>>;
    type atMostLength<rule> = brand<string, AtMostLength<rule>>;
    type lessThanLength<rule> = brand<string, LessThanLength<rule>>;
    type exactlyLength<rule> = brand<string, ExactlyLength<rule>>;
    type matching<rule> = brand<string, Matching<rule>>;
    type narrowed = brand<string, Narrowed>;
    type optional = brand<string, Optional>;
    type defaultsTo<rule> = brand<string, Default<rule>>;
    type branded<rule> = brand<string, Predicate<rule>>;
    type is<attributes> = brand<string, attributes>;
    type applyBrand<attribute> = attribute extends ExactlyLength<infer rule> ? exactlyLength<rule> : attribute extends MoreThanLength<infer rule> ? moreThanLength<rule> : attribute extends AtLeastLength<infer rule> ? atLeastLength<rule> : attribute extends AtMostLength<infer rule> ? atMostLength<rule> : attribute extends LessThanLength<infer rule> ? lessThanLength<rule> : attribute extends Matching<infer rule> ? matching<rule> : attribute extends Optional ? optional : attribute extends Default<infer rule> ? defaultsTo<rule> : attribute extends Predicate<infer rule> ? branded<rule> : never;
}
export type { string as brandedString };
